#include "licznik.hpp"
#include <cstdlib>
#include <qinputdialog.h>
#include <iostream>
using namespace std;
Licznik::Licznik()
{
	ui.setupUi(this);
	port = new ManageSerialPort;
	connect (port, SIGNAL(newDataReceived(const QByteArray&)),
		this, SLOT (przyjmijDane(const QByteArray&)));

	port->setBaudRate(BAUD115200);
	port->setDataBits(DATA_8);
	port->setParity(PAR_NONE);
	port->setStopBits(STOP_2); 
	port->setFlowControl(FLOW_OFF);
	port->setTimeout(0, 10);
	port->enableReceiving();

	QStringList nazwy_portow;
#ifdef _TTY_POSIX_
	nazwy_portow << "/dev/ttyS0" << "/dev/ttyS1";
#endif
#ifdef _TTY_WIN_
	nazwy_portow << "COM1" << "COM2";
#endif
	bool okienko_ok;
	QString nazwa_portu = QInputDialog::getItem(this,
			tr("Port"), tr("Select port:"), nazwy_portow,
			0, TRUE, &okienko_ok);
	if ( okienko_ok )
		port->setPort(nazwa_portu);
	else
		exit(0); 
	// W przypadku wybrania "anuluj" nic innego nie pozostaje.	

	port->open();
	port->receiveData();
	liczba.reserve(8);
	liczba_krotka.reserve(8);
}

Licznik::~Licznik()
{
}

void Licznik::przyjmijDane(const QByteArray &dataReceived)
{	
	for (int i=0;i<dataReceived.size();++i)
	{
		if (dataReceived[i]=='a')
		{
			liczba.insert(1,':');
			liczba.insert(4,'.');
			if (liczba[6]=='0')
			{
				liczba_krotka=liczba;
				liczba_krotka[6]=' ';
				ui.label->setText(QString(liczba_krotka));
			}
			liczba.clear();
		}
		else if (dataReceived[i]=='z')
		{
			liczba.insert(1,':');
			liczba.insert(4,'.');
			ui.label->setText(QString(liczba));
			liczba.clear();
		}
		else liczba.prepend(dataReceived[i]);
	}
}
