#include "usart.h"
#include <avr/io.h>
#include <stdlib.h>

void USART_Init( unsigned int ubrr)
{
	// tryb asynchroniczny
	UCSRC &= ~(1 << UMSEL);

	// BaudRate
	UBRRH = (unsigned char)(ubrr>>8);
	UBRRL = (unsigned char)ubrr;

	// Wlaczony odbior
	UCSRB |= (1<<TXEN);

	// Format: 8 bitow danych, 2 bity stopu
	UCSRC |= (1<<UCSZ1)|(1<<UCSZ0) | (1<<USBS);
}

void USART_Transmit_char( unsigned char data )
{
	while ( !( UCSRA & (1<<UDRE)) );
	UDR = data;
}

void USART_Transmit_text(char * text,unsigned char size)
{
	//nadawanie konczy 0 lub wyslanie size znakow
	for(unsigned char i=0;((i<size)&(0!=text[i]));i++)
	  		USART_Transmit_char(text[i]);
}
