#include <avr/io.h>
#include <avr/interrupt.h>
#include "wyswietlacz.h"

ISR(_VECTOR(4),ISR_NOBLOCK)
{
	WyswietlCyfre();
}

void ObliczCyfry(unsigned int zmierzony_t)
{
	cyfry[centy_s]	= zmierzony_t%10;
	cyfry[decy_s ]	= (zmierzony_t%100)/10;
	cyfry[sek    ]	= (zmierzony_t%1000)/100;
	cyfry[deka_s ]	= (zmierzony_t%6000)/1000;
	cyfry[min    ]	= zmierzony_t/6000;
}

unsigned char ObliczNrCyfry()
{
	static unsigned char led_nr_cyfry=0;
	++led_nr_cyfry;
	if (led_nr_cyfry==5) led_nr_cyfry=0;
	return led_nr_cyfry;
}

void WyswietlCyfre()
{
	unsigned char temp_B = 0xff;
	unsigned char temp_nr = ObliczNrCyfry();
	char temp_cyfra = cyfry[temp_nr];
  
	/* wygas wszystko */
	PORTB = 0xff;
	PORTD |= (1 << PD6);


	/* wartosc cyfry */
	temp_B = (temp_cyfra << 3); // piny 4,5,6
	if (temp_cyfra%2) temp_B |= (1 << 7); // pin 7
	temp_B |= 0x0f; // trzeba zresetowac wybor cyfry
	
	/* wyslij wartosc cyfry */
	PORTB = temp_B;

	/* wyslij nr cyfry */
	if (temp_nr==0)	// nr 0 posiadaja centy sekundy,
					// wlaczamy zatem PD6
	{
		PORTD &= ~(1 << PD6);
	}
	// nr 1 posiadaja decysekundy, ale decysekundy s na PB0
	// i analogicznie z pozostalymi cyframi. Stad ten "-1"
	else PORTB &= ~(1 << (temp_nr-1));
	
}

void InicjujWyswietlacz(void)
{
	TCNT1 = 0;
	OCR1A = 7; // 16  * 1024/11059200 ~ 1ms

	/* Prescaler = FCPU/1024 */
	TCCR1B |= (1<<CS12)|(1<<CS10);
	TCCR1B &= ~(1<<CS11);

	TCCR1A &= ~(1<<WGM11);
	TCCR1A &= ~(1<<WGM10);

	/* CTC */
	TCCR1B |= (1<<WGM12);
	TCCR1B &= ~(1<<WGM13);

	TIMSK |= (1<<OCIE1A);
}
